#ifndef _RATECONN_H_
#define _RATECONN_H_

#include <map>
#include <deque>
#include <string>

#include <pthread.h>

typedef std::map<std::string, int> counterMap_t;
typedef std::deque<counterMap_t> countersDeque_t;


class RateconnTable {
public:
	RateconnTable(pthread_mutex_t *mutex, int numOfBuckets);
	void turn();
	void printAll();
	int incAndGet(const std::string& input);
//	~RateconnTable();


private:
	int m_numOfBuckets;
	countersDeque_t m_countersDeque;
	pthread_mutex_t *m_mutex;

};


#endif // _RATECONN_H_
